=== debian/changelog ===
asymptote (2.86+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Hilmar Preusse <hille42@web.de>  Mon, 12 Jun 2023 00:08:23 +0200
