## asymptote 2.86+ds1

=== debian/changelog ===
asymptote (2.86+ds1-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:45:52 +0100

asymptote (2.86+ds1-1) unstable; urgency=medium

  * Remove obsolete patches
  * Mark Debian-specific patches as "Forwarded: not-needed" in metadata.
  * Repack upstreams tar ball another time; remove files, which are
    (re)generated during build. Remove these files in clean target.
    (Closes: #1044090).

 -- Hilmar Preusse <hille42@web.de>  Mon, 11 Sep 2023 00:37:44 +0200
