## asymptote 2.87%2Bds

=== GUI/requirements.txt ===
numpy==1.22.0
cson==0.7
PyQt5==5.11
rsvg-convert==2.42.3
