=== LspCpp/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,16 @@
 option_if_not_defined(LSPCPP_MSAN "Build lsp with memory sanitizer" OFF)
 option_if_not_defined(LSPCPP_TSAN "Build lsp with thread sanitizer" OFF)
 option_if_not_defined(LSPCPP_INSTALL "Create lsp install target" OFF)
+option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC
+    "Enable support for Boehm GC. Boehm GC must be available by find_package(BDWgc CONFIG REQUIRED)." OFF)
+option_if_not_defined(LSPCPP_USE_CPP17 "Use C++17 for compilation. Setting this to off requires boost-optional." OFF)
+
+
+# Boehm GC
+
+if (LSPCPP_SUPPORT_BOEHM_GC)
+    find_package(BDWgc CONFIG REQUIRED)
+endif()
 
 ###########################################################
 # Directories
@@ -89,8 +99,12 @@
 
     set_property(TARGET ${target} PROPERTY CXX_STANDARD_REQUIRED ON)
 
-    # Enable C++14 (Required)
-    set_property(TARGET ${target} PROPERTY CXX_STANDARD 14)
+    # Enable C++14/17 (Required)
+    if (LSPCPP_USE_CPP17)
+        set_property(TARGET ${target} PROPERTY CXX_STANDARD 17)
+    else()
+        set_property(TARGET ${target} PROPERTY CXX_STANDARD 14)
+    endif()
 
     set_property(TARGET ${target} PROPERTY CXX_EXTENSIONS OFF)
 
@@ -151,6 +165,11 @@
     # if(NOT MSVC)
     #     target_compile_options(${target} PRIVATE "-Wl,--no-undefined")
     # endif()
+
+    if (LSPCPP_SUPPORT_BOEHM_GC)
+        target_link_libraries(${target} PUBLIC BDWgc::gc)
+        target_compile_definitions(${target} PUBLIC LSPCPP_USEGC)
+    endif()
 
 endfunction()
 
@@ -315,20 +334,3 @@
     ###########################################################
     if(CMAKE_SYSTEM_NAME MATCHES "Windows")
         set(LSPCPP_OS_LIBS WS2_32)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
-        set(LSPCPP_OS_LIBS pthread)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
-        set(LSPCPP_OS_LIBS)
-    endif()
-
-    function(build_example target)
-        add_executable(${target} "${CMAKE_CURRENT_SOURCE_DIR}/examples/${target}.cpp")
-        target_include_directories(${target} PRIVATE ${Uri_SOURCE_DIR}/include)
-        set_target_properties(${target} PROPERTIES
-                FOLDER "Examples"
-                )
-        lspcpp_set_target_options(${target})
-        target_link_libraries(${target}  PRIVATE lspcpp "${LSPCPP_OS_LIBS}")
-    endfunction(build_example)
-
-    set(EXAMPLES
