## asymptote 2.87+ds

=== cudareflect/tinyexr/examples/deepview/Makefile ===
all:
	g++ -I ../../deps/miniz -o deepview -g -O2 main.cc trackball.cc ../../tinyexr.cc ../../deps/miniz/miniz.c -framework OpenGL -framework GLUT
