=== debian/changelog ===
asymptote (2.87+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:24:44 +1100

asymptote (2.87+ds-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:41:25 +0000

asymptote (2.87+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Replace freeglut3-dev by libglut-dev in control file of test suite.
  * Remove libboost-dev from control file of test suite.
  * Run test suite during build (Closes: #1061151).
  * Add libtirpc-dev to build depends of asymptote and test suite
    (Closes: #1065212).

 -- Hilmar Preusse <hille42@web.de>  Sat, 02 Mar 2024 23:29:20 +0100
