=== debian/tests/control ===
Tests: test-suite
Depends: bison,
	dh-python,
	dpkg-dev (>= 1.16.1),
	build-essential,
	doxygen,
	graphviz,
	flex,
	cmake,
	pkg-config,
	libglut-dev,
	libosmesa6-dev,
	ghostscript,
	imagemagick,
	libeigen3-dev,
	libfftw3-dev,
	libgc-dev,
	libgsl-dev,
	libncurses-dev,
	libreadline-dev,
	libsigsegv-dev,
	libtimedate-perl,
	libtirpc-dev,
	python3,
	pyqt5-dev-tools,
	zlib1g-dev,
	libboost-program-options-dev,
	libboost-filesystem-dev,
	libboost-thread-dev,
	libcurl4-gnutls-dev,
	libglm-dev,
	libglew-dev,
	texlive-latex-base
Restrictions: build-needed, allow-stderr
