## asymptote 2.89+ds

=== debian/changelog ===
asymptote (2.89+ds-1ubuntu1) oracular; urgency=medium

  * Fix autopkgtest following dpkg changes (LP: #2071468)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 29 Jun 2024 20:29:47 -0400

asymptote (2.89+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Lintian:
    - W: build-depends-on-obsolete-package
    - W: superfluous-file-pattern
  * Bump Standards version, no changes needed.

 -- Hilmar Preusse <hille42@web.de>  Sat, 27 Apr 2024 10:07:57 +0200
