=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-python,
                flex,
                cmake,
-               pkg-config,
+               pkgconf,
                libglut-dev,
                libosmesa6-dev,
                ghostscript,
@@ -46,7 +46,7 @@
                zlib1g-dev,
                libglm-dev,
                libglew-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://asymptote.sourceforge.net/
 Vcs-Git: https://github.com/debian-tex/asymptote.git
