=== debian/tests/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	graphviz,
 	flex,
 	cmake,
-	pkg-config,
+	pkgconf,
 	libglut-dev,
 	libosmesa6-dev,
 	ghostscript,
