## asymptote 2.90+ds

=== debian/changelog ===
asymptote (2.90+ds-1build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:15:12 +0200

asymptote (2.90+ds-1) unstable; urgency=medium

  * New upstream version, refresh patches.

  * Test installed asy package instead of rebuilding it in autopkg
    test suite. Thanks to Sven Joachim for the bug report and idea
    how to implement (Closes: #1061152).

  [ Jeremy Bícha ]
  * Fix autopkgtest following dpkg changes (LP: #2071468)

 -- Hilmar Preuße <hille42@debian.org>  Sun, 21 Jul 2024 12:08:06 +0200
