## asymptote 2.91+ds

=== debian/changelog ===
asymptote (2.91+ds-1) unstable; urgency=medium

  * New upstream version, refresh patches.
  * Fix d/copyright a little bit thanks to licenserecon.

 -- Hilmar Preuße <hille42@debian.org>  Wed, 04 Sep 2024 23:49:15 +0200
