## asymptote 2.92+ds

=== debian/changelog ===
asymptote (2.92+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Lintian:
      W: asymptote source: missing-license-paragraph-in-dep5-copyright
      W: asymptote source: space-in-std-shortname-in-dep5-copyright

 -- Hilmar Preuße <hille42@debian.org>  Sat, 12 Oct 2024 00:12:41 +0200
