=== LspCpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.8)
+cmake_minimum_required(VERSION 3.16)
 
 if(POLICY CMP0025)
     # detect Apple's Clang
@@ -43,15 +43,32 @@
 option_if_not_defined(LSPCPP_MSAN "Build lsp with memory sanitizer" OFF)
 option_if_not_defined(LSPCPP_TSAN "Build lsp with thread sanitizer" OFF)
 option_if_not_defined(LSPCPP_INSTALL "Create lsp install target" OFF)
-option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC
-    "Enable support for Boehm GC. Boehm GC must be available by find_package(BDWgc CONFIG REQUIRED)." OFF)
+option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC "\
+Enable support for Boehm GC. GC must be specified LSPCPP_GC_DOWNLOADED_ROOT, if downloaded or by
+find_package(BDWgc CONFIG REQUIRED) or pkg_config." OFF)
 option_if_not_defined(LSPCPP_USE_CPP17 "Use C++17 for compilation. Setting this to off requires boost-optional." OFF)
 
-
+set(LSPCPP_GC_DOWNLOADED_ROOT "" CACHE STRING "\
+If using downloaded gc root from https://www.hboehm.info/gc/, extract its contents and set this setting to
+where the tar.gz file is extracted to. This directory must be an absolute path.
+If this setting is set, LspCpp will use downloaded GC regardless of whether GC from find_package or
+pkg_config is available or not.
+")
+
+###########################################################
 # Boehm GC
-
-if (LSPCPP_SUPPORT_BOEHM_GC)
-    find_package(BDWgc CONFIG REQUIRED)
+###########################################################
+
+if (LSPCPP_SUPPORT_BOEHM_GC AND NOT LSPCPP_GC_DOWNLOADED_ROOT)
+    message(STATUS "Attempting to find BDWgc by find_package")
+    find_package(BDWgc CONFIG)
+    if (NOT BDWgc_FOUND)
+        set(GC_USE_PKGCONFIG 1)
+        # fallback to pkg-config
+        message(STATUS "CMake config for BDWgc not found; falling back to pkg-config")
+        find_package(PkgConfig REQUIRED)
+        pkg_check_modules(gc REQUIRED IMPORTED_TARGET bdw-gc)
+    endif()
 endif()
 
 ###########################################################
@@ -167,7 +184,27 @@
     # endif()
 
     if (LSPCPP_SUPPORT_BOEHM_GC)
-        target_link_libraries(${target} PUBLIC BDWgc::gc)
+        if (LSPCPP_GC_DOWNLOADED_ROOT)
+            message(STATUS "Using manually downloaded GC")
+            target_include_directories(${target} PUBLIC ${LSPCPP_GC_DOWNLOADED_ROOT}/include)
+        else()
+            if (NOT GC_USE_PKGCONFIG)
+                message(STATUS "Using cmake config for locating gc")
+                target_link_libraries(${target} PUBLIC BDWgc::gc)
+                get_target_property(GC_INCLUDE_DIRS_BASE BDWgc::gc INTERFACE_INCLUDE_DIRECTORIES)
+            else()
+                message(STATUS "Using pkg-config for locating gc")
+                target_link_libraries(${target} PUBLIC PkgConfig::gc)
+                get_target_property(GC_INCLUDE_DIRS_BASE PkgConfig::gc INTERFACE_INCLUDE_DIRECTORIES)
+            endif()
+
+            if (NOT GC_INCLUDE_DIRS_BASE STREQUAL "GC_INCLUDE_DIRS_BASE-NOTFOUND")
+                list(TRANSFORM GC_INCLUDE_DIRS_BASE APPEND /gc)
+                target_include_directories(${target} PUBLIC ${GC_INCLUDE_DIRS_BASE})
+            else()
+                message(WARNING "Cannot find GC include directories; compilation may not work")
+            endif()
+        endif()
         target_compile_definitions(${target} PUBLIC LSPCPP_USEGC)
     endif()
 
@@ -261,76 +298,3 @@
 endforeach()
 
 ### Sources
-set(JSONRPC_LIST
-        src/jsonrpc/Context.cpp
-        src/jsonrpc/Endpoint.cpp
-        src/jsonrpc/GCThreadContext.cpp
-        src/jsonrpc/message.cpp
-        src/jsonrpc/MessageJsonHandler.cpp
-        src/jsonrpc/RemoteEndPoint.cpp
-        src/jsonrpc/serializer.cpp
-        src/jsonrpc/StreamMessageProducer.cpp
-        src/jsonrpc/TcpServer.cpp
-        src/jsonrpc/threaded_queue.cpp
-)
-set(LSPCPP_LIST
-        src/lsp/initialize.cpp
-        src/lsp/lsp.cpp
-        src/lsp/lsp_diagnostic.cpp
-        src/lsp/Markup.cpp
-        src/lsp/ParentProcessWatcher.cpp
-        src/lsp/ProtocolJsonHandler.cpp
-        src/lsp/textDocument.cpp
-        src/lsp/utils.cpp
-        src/lsp/working_files.cpp
-        )
-
-if(LSPCPP_BUILD_WEBSOCKETS)
-    set(JSONRPC_LIST
-        ${JSONRPC_LIST}
-        src/jsonrpc/WebSocketServer.cpp
-    )
-endif()
-
-target_sources(lspcpp PRIVATE
-        ${JSONRPC_LIST}
-        ${LSPCPP_LIST})
-
-### Compile options
-
-lspcpp_set_target_options(lspcpp)
-
-set_target_properties(lspcpp PROPERTIES POSITION_INDEPENDENT_CODE 1)
-
-# install
-if(LSPCPP_INSTALL)
-    include(GNUInstallDirs)
-
-    install(DIRECTORY ${LSPCPP_INCLUDE_DIR}/LibLsp
-            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-            USE_SOURCE_PERMISSIONS
-            )
-
-    install(TARGETS lspcpp
-            EXPORT lspcpp-targets
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-            )
-
-    install(EXPORT lspcpp-targets
-            FILE lspcpp-config.cmake
-            NAMESPACE lspcpp::
-            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lspcpp
-            )
-endif()
-
-# examples
-if(LSPCPP_BUILD_EXAMPLES)
-
-    ###########################################################
-    # OS libraries
-    ###########################################################
-    if(CMAKE_SYSTEM_NAME MATCHES "Windows")
-        set(LSPCPP_OS_LIBS WS2_32)
