=== debian/changelog ===
asymptote (2.95+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
    - d/copyright: upstream restructured repo, update exclude pattern.

 -- Hilmar Preuße <hille42@debian.org>  Sat, 30 Nov 2024 00:12:57 +0100
