=== debian/control ===
--- 
+++ 
@@ -31,6 +31,7 @@
                libtimedate-perl,
 	       libtirpc-dev,
                python3,
+               python3-click,
                pyqt5-dev-tools,
                rapidjson-dev,
                tex-common,
