=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	ln -sf ../share/asymptote/GUI/xasy.py debian/tmp/usr/bin/xasy
 	# fix permissions
 	chmod 0644 debian/tmp/usr/share/asymptote/shaders/*.glsl
-	chmod 0644 debian/tmp/usr/share/asymptote/GUI/icons_rc.py
+	#chmod 0644 debian/tmp/usr/share/asymptote/GUI/icons_rc.py
 	dh_installtex -pasymptote
 
 #override_dh_auto_test:
