=== debian/tests/control ===
Tests: test-suite
Depends: asymptote
Restrictions: allow-stderr
